-- enable only the official ball for SK Spassball
--local itemName = "Lustiger Spaßstein";
local itemName = "Schwerer Lederball";
--local itemName = "Ruhestein";

-- mark this one true when developing
local printOnly = false; 

-- Initial OnLoad Function that will create and configure the button
function OnLoad()
	btn = CreateFrame("Button", "Throw", nil, "SecureActionButtonTemplate,UIPanelButtonTemplate");
	btn:SetAttribute("type", "macro");
	btn:SetAttribute("macrotext1", "/use "..itemName.."");
	btn:SetScript("PostClick", function(self) HandleLogic(); end);
	btn:SetSize(60, 40);
	btn:SetPoint("BOTTOMLEFT", nil, 5, 5);
	
	-- make it drag-dropable
	btn:SetMovable(true);
	btn:EnableMouse(true);
	btn:RegisterForDrag("RightButton");
	btn:SetScript("OnDragStart", btn.StartMoving);
	btn:SetScript("OnDragStop", btn.StopMovingOrSizing);
	
	-- give it a label
	btn:SetText("Werfen");
end

-- handle logic method to be executed after throwing the ball
function HandleLogic()
	gender = UnitSex("player");
	local inBag = IsInBag();
	if(inBag == true) then
		own = math.random(1,10);	
		if(own % 2 == 0) then
			-- even - throw hit
			target = math.random(1,10);
			if(target % 2 == 0) then
				-- even - target catched (defense worked)
				PrintMessage("wirft "..itemName.." auf %t ("..own..") doch %t fängt ihn! ("..target..")","EMOTE");
			else
				-- odd - target hit (defense failed)
				PrintMessage("wirft "..itemName.." auf %t ("..own..") und trifft! ("..target..")","EMOTE");
			end
		else
			-- odd - throw missed
			PrintMessage("wirft "..itemName.." auf %t ("..own..") und verfehlt!","EMOTE");
		end 
	else
		print("|cffFF0000Du hast gar keinen "..itemName.."!|r");
		if(gender == 2) then 
			PrintMessage("versucht "..itemName.." auf %t zu werfen und stellt dann fest, dass sie gar keinen "..itemName.." in der Hand hat!","EMOTE");
		else
			PrintMessage("versucht "..itemName.." auf %t zu werfen und stellt dann fest, dass er gar keinen "..itemName.." in der Hand hat!","EMOTE");
		end
	end
	
end

-- adding slash commands for the addon
SLASH_SPASSBALL1, SLASH_SPASSBALL2 = '/sirius', '/spassball'; -- 3.
SlashCmdList.SPASSBALL = SpassballCommand;

-- the method to be executed when /command is typed
function SpassballCommand(msg, editbox) -- 4.
	if(printOnly) then
		gender = UnitSex("player");
		print ("Player Gender = "..gender.."");
		if(IsInBag()) then
		print("Ja "..itemName.." - ID: "..GetItemId().."");
		else
		print("Nein "..itemName.."");
		end
	else

	--print("|cffFF0000This text is red|r This text is white |cff00FF00This text is green|r |cff0000FFThis text is blue|r");
	print("Willkommen zum |cffFF0000Sirius Kult|r Spassball Addon!");
	print("Mit |cff0000FF/sirius|r oder |cff0000FF/spassball|r kann diese Hilfe aufgerufen werden.");
	print("Den Button kannst du mit Rechtsklick hinschieben wo du ihn gerne hättest.");
	print("Linksklick wird den Ball auf den anvisierten Spieler werfen und 2x intern 1-10 würfeln.");
	print("Der erste Wurf entspricht dabei deinem Versuch und der zweite dem des Ziels - der höhere wurf fängt den Ball oder wird getroffen.");
	end
end

-- internal get item id method to handle supported items based on config above
function GetItemId()
	if(itemName == "Schwerer Lederball") then
		return 18662; -- schwerer Lederball
	end
	
	if(itemName == "Lustiger Spaßstein") then
		return 18640; --Lustiger Spaßstein
	end
	
	if(itemName == "Ruhestein") then
		return 6948; --Ruhestein
	end
end

-- To be used for public methods - will print instead of emote / say and thus can be used for debugging
function PrintMessage(message, mode)
	if(printOnly) then
		print(message);
	else
		SendChatMessage(message, mode);
	end
end

-- Checks if the ball-item configured on top is available in the players bag
function IsInBag()
	local result = false;
	local item, itemLink = GetItemInfo(GetItemId())
     for bag = 0, NUM_BAG_SLOTS do
		if(result) then break; end
         for slot = 1, GetContainerNumSlots(bag) do
			local current = GetContainerItemLink(bag, slot);
             if(current == itemLink) then
                result = true
				break;
             end
         end
    end
	return result;
end